"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const service_decorator_1 = require("../decorators/services/service.decorator");
const cin_1 = require("../util/cin");
const server_1 = require("../server/server");
let ReplService = class ReplService {
    constructor(server) {
        this.server = server;
    }
    get logger() {
        return this.server.logger;
    }
    start() {
        return __awaiter(this, void 0, void 0, function* () {
            this.context = yield this.makeContext();
            this.loopPromise = this.repl();
        });
    }
    makeContext() {
        return __awaiter(this, void 0, void 0, function* () {
            let ctx = {};
            // let models = this.server.meta.models;
            // if (models) {
            //     for (let q = 0; q < models.length; q++) {
            //         ctx[models[q].name] = this.server.injector.resolveInjectable(models[q]);
            //     }
            // }
            // ctx.Server = this.server;
            ctx.fish = 'apple';
            return ctx;
        });
    }
    executeInContext(code, context) {
        if (context)
            return this.executeInContext.call(context, code);
        try {
            return eval(code);
        }
        catch (e) {
            console.error('repl', e && (e.message || e));
        }
    }
    repl() {
        return __awaiter(this, void 0, void 0, function* () {
            while (true) {
                let line = yield cin_1.cin.readline();
                if (line == 'exit')
                    break;
                console.log(this.executeInContext(line, this.context));
            }
        });
    }
    stop() {
        return __awaiter(this, void 0, void 0, function* () {
            cin_1.cin.emit('exit');
            yield this.loopPromise;
        });
    }
};
ReplService = __decorate([
    service_decorator_1.Service(),
    __metadata("design:paramtypes", [server_1.Server])
], ReplService);
exports.ReplService = ReplService;
//# sourceMappingURL=repl.service.js.map